#include "IDAReplayObserver.h"
#include "Util.h"

void IDAReplayObserver::setUnits()
{
	
	m_allUnits.clear();
	Control()->GetObservation();
	for (auto & unit : Observation()->GetUnits())
	{
		m_allUnits.push_back(UnitInformation(unit, *this));
	}
	

}

IDAReplayObserver::IDAReplayObserver():
	sc2::ReplayObserver()
{
}

void IDAReplayObserver::OnGameStart()
{
	

	setUnits();

}

void IDAReplayObserver::OnStep()
{
	setUnits();
}

void IDAReplayObserver::OnGameEnd()
{
}

UnitInformation IDAReplayObserver::GetUnit(const CCUnitID tag) const
{		
	return UnitInformation(Observation()->GetUnit(tag), *(IDAReplayObserver *)this);
}






const std::vector<UnitInformation>& IDAReplayObserver::GetAllUnits() const
{

	return m_allUnits;
}


